#pragma once
#include "fs/VFS.h"
#include "fs/devices/DeviceRegistry.h"

namespace DevPTS
{
    class FileSystem : public VFS::FileSystem
    {
      public:
        SharedPtr<VFS::Inode> root_inode() const override
        {
            return m_root_inode;
        }

        Result<SharedPtr<VFS::Inode>> create_file_inode(mode_t) override
        {
            return err(ENOTSUP);
        }

        Result<SharedPtr<VFS::Inode>> create_dir_inode(SharedPtr<VFS::Inode>, mode_t) override
        {
            return err(ENOTSUP);
        }

        Result<SharedPtr<VFS::Inode>> create_device_inode(u32, u32, mode_t) override
        {
            return err(ENOTSUP);
        }

        Result<SharedPtr<VFS::Inode>> create_symlink_inode(StringView) override
        {
            return err(ENOTSUP);
        }

        Result<u64> allocate_inode_number() override;

        Result<void> set_mount_dir(SharedPtr<VFS::Inode> parent) override;

        Result<void> reset_mount_dir() override;

        static Result<SharedPtr<VFS::FileSystem>> create();

        dev_t host_device_id() const override
        {
            return m_host_device_id;
        }

        virtual ~FileSystem();

      private:
        FileSystem();

        void set_root(SharedPtr<VFS::Inode> root);

        SharedPtr<VFS::Inode> m_root_inode;

        dev_t m_host_device_id;
    };
}

extern Vector<VFS::FileSystem*> g_devpts_instances;
